#!/usr/bin/env python
# encoding: utf-8
#
###########################################################################
#     Sint Wind PI
#     Copyright 2012 by Tonino Tarsi <tony.tarsi@gmail.com>
#   
#     USB comunication based pywws by 'Jim Easterbrook' <jim@jim-easterbrook.me.uk>
#     Please refer to the LICENSE file for conditions 
#     Visit http://www.vololiberomontecucco.it
# 
##########################################################################

""" SWPIbot v.0.9.2 - A Telegram bot plugin for SWPI by Nicola 'Seven' """


import threading
import datetime
import sqlite3
import sys
import subprocess
import sys 
import os
import thread
import time
import globalvars
import meteodata
from TTLib import  *
import RPi.GPIO as GPIO
import telegram
from telegram.ext import Updater
import random
import logging

logging.basicConfig(level=logging.DEBUG,
                    format='%(asctime)s - %(name)s - %(levelname)s - %(message)s')
		
		

class swpi_plugin(threading.Thread):  #  do not change the name of the class
    
	def __init__(self,cfg):
		self.cfg = cfg
		threading.Thread.__init__(self)
	
		
        
        ###################### Plugin Initialization ################
		
		
        ###################### End Initialization ###################
        
        
	def run(self):
		
		log("Starting plugin : %s" % sys.modules[__name__])
		
		###################### Plugin run
		try:
			cfg = self.cfg
			SWPIbot(cfg)
		except:
			log("Invoke class SWPIbot failed!")
		###################### end of Plugin run
		
			
			
class SWPIbot(threading.Thread):
	


	# SWPIbot, un semplice bot per Telegram di 'Seven', Nik.
	#
	# Sentiti libero di usare, modificare e distribuire questo software come preferisci,
	# purché software e derivati rimangano a loro volta gratuiti e  ***solo per uso NON commerciale***.
	#
	# Utilizzando questo software accetti che NESSUNA GARANZIA lo accompagna:
	# lo ricevi così com'è e lo utilizzi a tuo rischio e pericolo.
	#
	########################################################################
	#
	#
	# Utilizza il tuo client Telegram per contattare l'utente 'BotFather' e dirgli '/newbot' per creare
	# il tuo nuovo bot. Al termine del processo BotFather ti ritornerà una lunga stringa di testo detta 'token'.
	# Incolla il token nell'apposita linea BotToken più in basso, sovrascrivendo le 'xxxxxxxxxx' che contiene,
	# quindi riavvia SWPI. Nei logs di SWPI dovresti ora vedere che il tuo bot è in ascolto.
	
	# Ora nel client Telegram utilizza la funzione di ricerca utente per trovare il tuo bot 
	# e clicca il pulsante 'Avvia' (equivale a dare al bot il comando '/start'). 
	# Alla sua risposta digli 'sysadmin' (senza slash), diventerai così il suo Amministratore.
	# Solo il primo utente che gli dirà sysadmin diverrà il suo amministratore, 
	# perciò accertati di essere il primo! :)
	
	# Dì 'help' o 'aiuto' al bot per vedere quali sono i comandi che accetta.
	# I comandi che iniziano con slash ('/') possono essere utilizzati soltanto dagli Amministratori (Admin).
	
	# Come impostazione predefinita il bot risponde solo agli utenti autorizzati.
	# Per aggiungere utenti alla lista di utenti autorizzati procedi in questo modo:
	
	# - l'utente che desidera essere aggiunto alla lista dovrà dire #ciao# al bot;
	# - il bot gli risponderà con un messaggio formattato in modo particolare;
	# - l'utente dovrà ora girare a te Admin questo stesso messaggio che ha ricevuto dal bot;
	# - tu Admin inoltrerai di nuovo quel messaggio al bot stesso, così il cerchio si chiude.
	# A quel punto l'utente è registrato. Potrai renderlo a sua volta Admin o cancellarlo 
	# grazie ad una specie di lista utenti interattiva accessibile con il comando /list.	
	
	# In quanto Admin, tu puoi anche aprire l'accesso al bot a chiunque (modo 'FREEACCESS'),
	# non solo ad utenti registrati, utilizzando il comando /free . 
	# Naturalmente i comandi per Admin (quelli che iniziano con '/') rimarranno accessibili solo a te 
	# ed agli Admin da te designati.
	# Per disabilitare il modo FREEACCESS utilizza il comando /nofree .
	
	# Il file SWPIbot.db è il DataBase contenente gli utenti ed il loro status (se sono admin o no).
	# Se qualcosa va storto sovrascrivilo utilizzando il file SWPIbot.db.DEFAULT ,
	# che è una copia vuota del DB. 
	# Ovviamente perderai qualsiasi dato contenuto e dovrai ripetere da capo lo step 'sysadmin'
	# prima di chiunque altro per divenire Admin del bot, inoltre ogni utente dovrà ripetere da capo
	# la procedura di registrazione vista in precedenza.
	#
	# Buon Divertimento!
	#
	#######################################################################################################################
	
	
	# SWPIbot, a simple bot for Telegram by 'Seven', Nik. 
	# 
	# You are free to use this software, distribute and modify it as you wish ***for non-commercial use only***.
	# By using this software you agree that NO WARRANTY of any kind is given by its use: 
	# you received it 'as is' and you use it at your own risk.
	#
	#######################################################################
	#
	#
	# Open your Telegram client and say '/newbot' to the 'BotFather' bot to create your new bot.
	# At the end of the process, the BotFather will give you a long text string so called 'token'.
	# Paste the token in the BotToken line below (overwriting all of the 'x' that you see now), then restart SWPI. 
	# In the logs you should see that your bot is now listening.
	
	# Now search your bot's name in your Telegram client by using the 'Search' function, 
	# then say '/start' to him.
	# When he will say that you are not authorized to talk with him, say 'sysadmin' (with no slash)
	# and you will become an authorized user and also an Admin.
	# Nobody else than the first user can use 'sysadmin' command, so be sure to be the first :)
	
	# Say 'help' to the bot to see all of the commands he can understand. 
	# Commands starting with '/' can be used by Admins only.
	
	# By default the bot will answer to authorized users only. 
	# To add users to your authorized list, tell to your (wannabe) user to say #ciao# to your bot, 
	# then he should send you (in Telegram) the bot's answer he will get (it's a particular message).
	# 
	# You should then forward to the bot this same particular message you just received from the user: 
	# because you are an Admin, the bot will create the new user.
	
	# You can edit users, making them Admins and delete them with (sort of) an interactive menu: 
	# just say  /list  to the bot to navigate in it.
	#
	# You (as Admin) can also open bot access to everybody ('FREEACCESS mode') by saying '/free' to the bot.
	# This will not affect Admins commands (still only Admins can use '/xyz' commands).
	#
	# To stop 'FREEACCESS mode' and return to 'registered users only' mode, just say '/nofree' to the bot.
	
	# The file SWPIbot.db is the database containing all of the users name and status. If something goes wrong,
	# you can overwrite it using the file SWPIbot.db.DEFAULT, which is an empty copy of the DB.
	# Obviously you will loose any user data, and you should start again with the 'sysadmin' step to become Admin!
	 
	# Peace! And have fun!
	#
	# Nik (Seven)
	#
	
	BotToken = "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx" # <---- Inserisci qui il Token del tuo bot / Paste here your bot Token
	
	botdb = '/swpi/plugins/SWPIbot.db'
	

	def __init__(self,cfg):
		self.cfg = cfg
		threading.Thread.__init__(self)
		self.run(cfg)
	
	@classmethod
	def botver(self):		
		return "SWPIbot 0.9.2 ITA"
	
	@classmethod
	def noauth(self, update):
		self.bot.sendMessage(update.message.chat_id, text="Hihihi... Lo sapevo che ci provavi!\n%s, amore mio, facciamo i furbetti?... " % self.nickname(update) + u"\U0001f60f" + "\nLo sai che a te non " + u"\xe8" + " concesso l\'utilizzo di questa funzione... "  + u"\U0001f48b")
		return
		
	@classmethod
	def unknowncmd(self, bot, update):
		cmd = (update.message.text).replace("/", "")
		if cmd.isnumeric():
			self.showuser(cmd, update)
		elif cmd[:2] == "SA":
			self.setadmin(cmd[2:], update)
		elif cmd[:2] == "DA":
			self.deadmin(cmd[2:], update)
		elif cmd[:2] == "DU":
			self.deluser(cmd[2:], update)
		else:
			pass
			

	@classmethod
	def showuser(self, user, update):
		sender = str(update.message.chat_id).strip()
		if self.isadmin(sender):
			if self.isuser(user):
				userdata = self.getuserdata(user, update)
				usermsg = "<b>Utente selezionato:</b>\n------------\n"
				usermsg += "<b>UserId:</b> %s \n" % userdata[1]
				usermsg += "<b>Nome:</b> %s \n" % userdata[2]
				if userdata[4] == 1:
					adm = "(l\'utente " + u"\xe8" + " un <b>Admin</b>)\n------------\n"
				else:
					adm = "(l\'utente <b>NON</b> " + u"\xe8" + " un Admin)\n------------\n"
				usermsg += adm
				usermsg += "\n<b>Operazioni disponibili per questo utente:</b>\n---------------\n"
				if userdata[1] == sender:
					usermsg += "<b>Nessuna</b>: non puoi operare su te stesso!\n"
					usermsg += "----------\nTorna alla lista\n/list\n"
					self.bot.sendMessage(update.message.chat_id, text=usermsg, parse_mode=telegram.ParseMode.HTML)
					return
				elif userdata[4] == 1:
					usermsg += "Rimuovere da Admin\n/DA%s\n\n" % userdata[1]
				elif userdata[4] == 0:
					usermsg += "Rendere Admin\n/SA%s\n\n" % userdata[1]
				usermsg += "Eliminare utente\n/DU%s\n\n" % userdata[1]
				usermsg += "----------\nTorna alla lista\n/list\n"
				
				self.bot.sendMessage(update.message.chat_id, text=usermsg, parse_mode=telegram.ParseMode.HTML)
				
			else:
				self.bot.sendMessage(update.message.chat_id, text="L\'utente %s non esiste!" % user, parse_mode=telegram.ParseMode.HTML)
		else:
			self.noauth(update)	
	
	@classmethod
	def setadmin(self, user, update):
		sender = str(update.message.chat_id).strip()
		if self.isadmin(sender):
			if self.isuser(user):
				if not user == 'ALL':
					con = None
					try:
						con = sqlite3.connect(self.botdb)			
						con.execute("""UPDATE users SET admin = 1 WHERE userid = "%s" """ % user)			
						con.commit()
						usermsg ="Utente %s aggiornato con successo.\n" % user
					except sqlite3.Error, e:
						print "Error %s:" % e.args[0]
						usermsg ="ERRORE aggiornando i dati dell\'utente %s !\n" % user
					finally:
						if con:
							con.close()
				else:
					usermsg ="Impossibile dare a tutti lo stato di Admin!\nTi piacerebbe vedere (tra le altre cose) gente sconosciuta che mi reboota continuamente?\nComando <b>non</b> eseguito!\n"
			else:
				usermsg ="l\'utente %s non esiste!\n" % user			
			usermsg += "----------\nTorna alla lista\n/list\n"
			self.bot.sendMessage(update.message.chat_id, text=usermsg, parse_mode=telegram.ParseMode.HTML)
		else:
			self.noauth(update)	
			
	@classmethod
	def deadmin(self, user, update):
		sender = str(update.message.chat_id).strip()
		if self.isadmin(sender):
			if self.isuser(user):
				con = None
				try:
					con = sqlite3.connect(self.botdb)			
					con.execute("""UPDATE users SET admin = 0 WHERE userid = "%s" """ % user)			
					con.commit()
					usermsg ="Utente %s aggiornato con successo.\n" % user
				except sqlite3.Error, e:
					print "Error %s:" % e.args[0]
					usermsg ="ERRORE aggiornando i dati dell\'utente %s !\n" % user
				finally:
					if con:
						con.close()
			else:
				usermsg ="l\'utente %s non esiste!\n" % user			
			usermsg += "----------\nTorna alla lista\n/list\n"
			self.bot.sendMessage(update.message.chat_id, text=usermsg, parse_mode=telegram.ParseMode.HTML)
		else:
			self.noauth(update)	
			
	@classmethod
	def deluser(self, user, update):
		sender = str(update.message.chat_id).strip()
		if self.isadmin(sender):
			if self.isuser(user):
				con = None
				try:
					con = sqlite3.connect(self.botdb)			
					con.execute("""DELETE from users WHERE userid = "%s" """ % user)			
					con.commit()
					usermsg ="Utente %s eliminato con successo.\n" % user
				except sqlite3.Error, e:
					print "Error %s:" % e.args[0]
					usermsg ="ERRORE eliminando i dati dell\'utente %s !\n" % user
				finally:
					if con:
						con.close()
			else:
				usermsg ="l\'utente %s non esiste!\n" % user			
			usermsg += "----------\nTorna alla lista\n/list\n"
			self.bot.sendMessage(update.message.chat_id, text=usermsg, parse_mode=telegram.ParseMode.HTML)
		else:
			self.noauth(update)	

	@classmethod		
	def getuserdata(self, user, update):
		sender = str(update.message.chat_id).strip()
		if self.isadmin(sender):
			con = None
			try:
				con = sqlite3.connect(self.botdb)			
				cur = con.cursor()    
				cur.execute("""SELECT * FROM users where userid = "%s" """ % user)			
				data = cur.fetchall()
			except sqlite3.Error, e:
				print "Error %s:" % e.args[0]
			finally:
				if con:
					con.close()
			return data[0]
		else:
			self.noauth(update)
		##################################################
		# data[0] = db id
		# data[1] = userid
		# data[2] = name1
		# data[3] = name2
		# data[4] = is user admin? (0 = false / 1 = true)
		##################################################
		
	
	@classmethod	
	def set_freeaccess(self, bot, update):
		sender = str(update.message.chat_id).strip()
		if self.isadmin(sender):
			if not self.isuser("ALL"):
				con = None
				try:
					con = sqlite3.connect(self.botdb)			
					con.execute("""INSERT INTO users (userid, name1, admin) VALUES ('%s','%s','0') """ % ("ALL","FREEACCESS"))	
					con.commit()
					usermsg ="Modalit"  + u"\xe0" + " <b>FREEACCESS</b> impostata con successo.\nL\'accesso alle mie funzioni " + u"\xe8" + " ora consentito a chiunque\n(funzioni Admin escluse).\n"
				except sqlite3.Error, e:
					print "Error %s:" % e.args[0]
					usermsg ="ERRORE impostando modalit" + u"\xe0" +" FREEACCESS!\n" 
				finally:
					if con:
						con.close()
					
				
			else:
				usermsg ="Modalit" + u"\xe0" +" <b>FREEACCESS</b> gi" +  u"\xe0" + " attiva!\n"
			usermsg += "----------\nVedi lista utenti:\n/list\n"
			self.bot.sendMessage(update.message.chat_id, text=usermsg, parse_mode=telegram.ParseMode.HTML)	
		else:
			self.noauth(update)	
	
	
	
	@classmethod	
	def set_no_freeaccess(self, bot, update):
		sender = str(update.message.chat_id).strip()
		if self.isadmin(sender):
			if self.isuser("ALL"):
				con = None
				try:
					con = sqlite3.connect(self.botdb)			
					con.execute("""DELETE from users WHERE userid = "%s" """ % ("ALL"))	
					con.commit()
					usermsg ="Modalit" + u"\xe0" +" <b>FREEACCESS</b> disabilitata.\nL\'accesso alle mie funzioni " + u"\xe8" + " ora consentito\nai soli utenti registrati.\n"
				except sqlite3.Error, e:
					print "Error %s:" % e.args[0]
					usermsg ="ERRORE disabilitando modalit" + u"\xe0" +" FREEACCESS!\n" 
				finally:
					if con:
						con.close()
					
				
			else:
				usermsg ="Modalit" + u"\xe0" +" <b>FREEACCESS</b> gi" +  u"\xe0" + " disabilitata!\n"
			usermsg += "----------\nVedi lista utenti:\n/list\n"
			self.bot.sendMessage(update.message.chat_id, text=usermsg, parse_mode=telegram.ParseMode.HTML)	
		else:
			self.noauth(update)	
	

		
	@classmethod
	def getcputemp(self):
		cputemp = os.popen('/opt/vc/bin/vcgencmd measure_temp').readline()
		cputemp = (cputemp.replace("temp=","").replace("'C\n",""))  
		return cputemp
		
	@classmethod
	def parla(self, update):
		self.bot.sendMessage(update.message.chat_id, text= "Solo un momento per l'elaborazione ...  ", parse_mode=telegram.ParseMode.HTML)
		if globalvars.meteo_data.last_measure_time != None:
			txtmessage = ("Dati raccolti  %s" % self.timeago() + " fa. ")		
			if ((globalvars.meteo_data.wind_dir_code) != None) :
				if globalvars.meteo_data.wind_dir_code == 'N':
					dirtxt = "Nord"
				elif globalvars.meteo_data.wind_dir_code == 'NNE':
					dirtxt = "Nord Nord est"
				elif globalvars.meteo_data.wind_dir_code == 'NE':
					dirtxt = "Nord est"
				elif globalvars.meteo_data.wind_dir_code == 'ENE':
					dirtxt = "Est Nord est"
				elif globalvars.meteo_data.wind_dir_code == 'E':
					dirtxt = "Est"
				elif globalvars.meteo_data.wind_dir_code == 'ESE':
					dirtxt = "Est Sud Est"
				elif globalvars.meteo_data.wind_dir_code == 'SE':
					dirtxt = "Sud Est"
				elif globalvars.meteo_data.wind_dir_code == 'SSE':
					dirtxt = "Sud Sud Est"
				elif globalvars.meteo_data.wind_dir_code == 'S':
					dirtxt = "Sud"
				elif globalvars.meteo_data.wind_dir_code == 'SSW':
					dirtxt = "Sud Sud Ovest"
				elif globalvars.meteo_data.wind_dir_code == 'SW':
					dirtxt = "Sud Ovest"
				elif globalvars.meteo_data.wind_dir_code == 'WSW':
					dirtxt = "Ovest Sud Ovest"
				elif globalvars.meteo_data.wind_dir_code == 'W':
					dirtxt = "Ovest"
				elif globalvars.meteo_data.wind_dir_code == 'WNW':
					dirtxt = "Ovest Nord Ovest"
				elif globalvars.meteo_data.wind_dir_code == 'NW':
					dirtxt = "Nord Ovest"
				elif globalvars.meteo_data.wind_dir_code == 'NNW':
					dirtxt = "Nord Nord Ovest"

				txtmessage += ("provenienza del vento %s. "% dirtxt)
			if ((globalvars.meteo_data.wind_ave) != None):
				txtmessage += ("velocità " + str(int(globalvars.meteo_data.wind_ave))+" chilometri orari. ")
			if ((globalvars.meteo_data.wind_gust) != None):
				txtmessage += ("raffica di %s" % str(int(globalvars.meteo_data.wind_gust)) + " chilometri orari. "  + "")
			if ((globalvars.meteo_data.temp_out) != None):
				txtmessage += ("temperatura %s"%str(globalvars.meteo_data.temp_out).strip()+ " gradi. " + "")
			if ((globalvars.meteo_data.rel_pressure) != None):
				txtmessage += ("pressione %s" % (globalvars.meteo_data.rel_pressure) + " ettopascal. "  + "")
			if ((globalvars.meteo_data.hum_out) != None):
				txtmessage += ("umidità relativa %s" % str(int(globalvars.meteo_data.hum_out)) + "%. " + "")
			if ((globalvars.meteo_data.cloud_base_altitude) != None):
				txtmessage += ("La base cuumulo è posta a %s" % str(int(globalvars.meteo_data.cloud_base_altitude)) + " metri. "  + "")
			txtmessage += ("Arisentirci amoore. ")
			random_number = str(random.randrange(999999999999999))
			filename = random_number + '.wav'
			fileout = random_number + '.ogg'
			os.system("pico2wave -l \"it-IT\" -w /dev/shm/%s \"%s\"" % (filename, txtmessage))
			self.bot.sendMessage(update.message.chat_id, text= "... Ancora un secondo, eh... Sono solo una RaspberryPi ...", parse_mode=telegram.ParseMode.HTML)
			oggfile = os.system("oggenc \"/dev/shm/%s\" --output=\"/dev/shm/%s\"" % (filename, fileout))
			self.bot.sendVoice(chat_id=update.message.chat_id, voice=open('/dev/shm/' + fileout, 'rb'))		
			os.remove("/dev/shm/" + filename)
			os.remove("/dev/shm/" + fileout)
		else:
			txtmessage = ("Dati non ancora disponibili. Riprova più tardi amore. ")
			random_number = str(random.randrange(999999999999999))
			filename = random_number + '.wav'
			fileout = random_number + '.ogg'
			os.system("pico2wave -l \"it-IT\" -w /dev/shm/%s \"%s\"" % (filename, txtmessage))
			oggfile = os.system("oggenc \"/dev/shm/%s\" --output=\"/dev/shm/%s\"" % (filename, fileout))
			self.bot.sendVoice(chat_id=update.message.chat_id, voice=open('/dev/shm/' + fileout, 'rb'))		
			os.remove("/dev/shm/" + filename)
			os.remove("/dev/shm/" + fileout)
			

	@classmethod				
	def start(self, bot, update):
		self.bot.sendMessage(update.message.chat_id, text="Ciao %s!" % self.nickname(update))
		
	@classmethod
	def nickname(self, update):
		nick = update.message.chat.first_name
		return nick
	
	
	@classmethod
	def isuser(self, user_id):
		con = None
		try:
			con = sqlite3.connect(self.botdb)			
			cur = con.cursor()    
			cur.execute("""SELECT userid FROM users where userid = "%s" """ % user_id)
			try:
				data = cur.fetchone()
				if not data[0] == None:
					return True
				else:
					return False
			except:
				return False
		except sqlite3.Error, e:
			print "Error %s:" % e.args[0]
		finally:
			if con:
				con.close()

		
	
	@classmethod
	def isadmin(self, user_id):
		con = None
		try:
			con = sqlite3.connect(self.botdb)			
			cur = con.cursor()    
			cur.execute('SELECT admin FROM users where userid = %s' % user_id)
			try:
				data = cur.fetchone()
				if data[0] == 1:
					return True
				else:
					return False
			except:
				return False
		except sqlite3.Error, e:
			print "Error %s:" % e.args[0]
		finally:
			if con:
				con.close()
		
	@classmethod
	def listusers(self, bot, update):
		sender = str(update.message.chat_id).strip()
		if self.isadmin(sender):
			con = None
			try:
				con = sqlite3.connect(self.botdb)			
				cur = con.cursor()    
				cur.execute("SELECT * FROM users WHERE userid <> 'ALL'")			
				data = cur.fetchall()
			except sqlite3.Error, e:
				print "Error %s:" % e.args[0]
			finally:
				if con:
					con.close()
			######################################################
			messagetxt = "<b>Lista utenti:</b>\n(seleziona un utente per modificarlo)\n---------------\n"
			for row in data:
				if row[4] == 1:
					adm = "(<b>Admin</b>)"
				else:
					adm = ""
				messagetxt += "/%s - %s %s\n" % (row[1],row[2],adm)
			if self.isuser('ALL'):
				messagetxt += "\nModalit" + u"\xe0" + " FREEACCESS <b>attiva</b>.\n"
			else:
				messagetxt += "\nModalit" + u"\xe0" + " FREEACCESS <b>non attiva</b>.\n"
				#print data[0] # db id
				#print data[1] # userid
				#print data[2] # name1
				#print data[3] # name2
				#print data[4] # is user admin? (0 = false / 1 = true)
			######################################################
			self.bot.sendMessage(update.message.chat_id, text=messagetxt, parse_mode=telegram.ParseMode.HTML)
		else:
			self.noauth(update)
	
	@classmethod				
	def adduser(self, update):
		txtmessage = (update.message.text)
		if "Inoltra questo messaggio all'Amministratore di SWPIbot" in txtmessage:
			txtmessage = txtmessage.replace("\'", "_")
			txtmessage = txtmessage.replace("\"", "_")
			user = str(update.message.chat_id).strip()		
			if self.isadmin(user):
				###################################### Parsing msg text for User data
				try:
					nstart = txtmessage.index("Nome:")
					nomeend = txtmessage.index("UserID:")
					nome = txtmessage[nstart + 5:nomeend].strip().encode("utf-8")
					uidend = txtmessage.index("_____________________")
					uid = str(txtmessage[nomeend + 7:(uidend)]).strip()
				except:
					self.bot.sendMessage(update.message.chat_id, text="ERRORE in lettura dati utente. Utente NON aggiunto.")
				###################################### End parsing

				if not self.isuser(uid): # Check if user is already in our list
					con = None
					try:
						con = sqlite3.connect(self.botdb)			
						con.execute("""INSERT INTO users (userid, name1, admin) VALUES ('%s','%s','0') """ % (uid, nome))	
						con.commit()
						self.bot.sendMessage(update.message.chat_id, text="Utente aggiunto con successo!\n")
					except sqlite3.Error, e:
						print "Error %s:" % e.args[0]
					finally:
						if con:
							con.close()
				else:
					self.bot.sendMessage(update.message.chat_id, text="Tesoro, questo utente è già presente in lista utenti.\nOperazione di aggiunta annullata.\n----------\nVedi lista\n/list\n ")
				return
			else:
				self.noauth(update)

				
		else:
			self.bot.sendMessage(update.message.chat_id, text="(DEBUG) - Errore in fase di interpretazione header nel comando adduser.\n ")

	
	@classmethod
	def timeago(self):
		if (not globalvars.meteo_data.last_measure_time == None) :
			value = globalvars.meteo_data.last_measure_time.strftime("[%d/%m/%Y-%H:%M:%S]")
			value = value.replace("[", "")
			value = value.replace("]", "")
			value = value.replace("-", " ")
			value = value.replace("/", "-")
			d1 = datetime.datetime.strptime(value, "%d-%m-%Y %H:%M:%S")
			d2 = datetime.datetime.strptime(datetime.datetime.today().strftime("%d-%m-%Y %H:%M:%S"), "%d-%m-%Y %H:%M:%S")
			sec = (d2 - d1).seconds
			if (sec < 60) :
				return ("%d secondi" % sec)
			else:
				return ("%d minuti" % int(round(sec / 60, -1)))
		else:
			return None
		
	@classmethod
	def webcam(self, update):
		try:

			################################################################################################
			## Area di scelta per le immagini webcam. E' possibile utilizzare un'immagine proveniente da web, 
			## oppure prelevarla dalla cartella /swpi/img (che dovrebbe contenere le immagini provenienti dalla webcam di swpi).
			##
			## Rimuovere il commento (#) dalle righe di interesse per renderle operative,
			## e/o commentare quelle non di interesse. Okkio a mantenere intatta l'indentazione del testo!
			##
			#####################
			##
			##   Le righe seguenti se scommentate salvano un'immagine proveniente dal web in /dev/shm e poi la spediscono via Telegram
			##   (sovrascrivere http://video.wifi4all.it/cam11.jpg con l'indirizzo web dell'immagine che si desidera)
			##
			#####################
			
			self.bot.sendMessage(update.message.chat_id, text= "... Cheeeeeese ...  " +  u'\U0001f4f8', parse_mode=telegram.ParseMode.HTML)
			os.system("curl --silent -o /dev/shm/snapshot.jpg http://video.wifi4all.it/cam11.jpg")
			self.bot.sendMessage(update.message.chat_id, text="Ecco l\'immagine che hai richiesto:", parse_mode=telegram.ParseMode.HTML)
			time.sleep(1)
			self.bot.sendPhoto(update.message.chat_id, photo=open('/dev/shm/snapshot.jpg', 'rb'))
			
			#####################
			##
			##  Le righe seguenti se scommentate prelevano l'immagine piu' recente da /swpi/img (se esistente) e la spediscono via Telegram
			##
			#####################
			
			#self.bot.sendMessage(update.message.chat_id, text= "... Cheeeeeese ...  " +  u'\U0001f4f8', parse_mode=telegram.ParseMode.HTML)
			#try:
			#	dir="img"
			#	files=os.listdir(dir)
			#	clips=len(files)
			#	list = sorted(files, key=lambda file: os.path.getmtime(os.path.join(dir, file)))
			#	image = list[-1]
			#	sendimg = dir + '/' + image
			#	print sendimg
			#	self.bot.sendMessage(update.message.chat_id, text="Ecco l\'immagine che hai richiesto:", parse_mode=telegram.ParseMode.HTML)
			#	time.sleep(1)
			#	self.bot.sendPhoto(update.message.chat_id, photo=open(sendimg, 'rb'))
			#except:
			#	self.bot.sendMessage(update.message.chat_id, text="Mi spiace, non esistono immagini nella cartella webcam. " +  u'\U0001f625', parse_mode=telegram.ParseMode.HTML)
				
			
			## 
			## Fine area di scelta immagini
			##
			####################################################################################################
			
		except:
			self.bot.sendMessage(update.message.chat_id, text="Mi spiace, per cause tecniche al momento non mi "+  u"\xe8" +" possibile soddisfare la tua richiesta. " +  u'\U0001f625', parse_mode=telegram.ParseMode.HTML)
		os.system("rm -f /dev/shm/snapshot.jpg")	
	
	@classmethod
	def eco(self, update):
		user = str(update.message.chat_id).strip()
		self.bot.sendMessage(update.message.chat_id, text="<b>Inoltra questo messaggio all\'Amministratore di SWPIbot per essere aggiunto tra gli utenti autorizzati ad accedere a questo servizio o per ricevere autorizzazioni speciali.</b>\n---------------------\nNome: <b>" + self.nickname(update) + "</b>\nUserID: <b>" + user + "</b>\n_____________________", parse_mode=telegram.ParseMode.HTML)
		
	@classmethod
	def info(self, update):
		if not self.timeago() == None :
			msg_timeago = ("\n\nL\'ultima rilevazione dati meteo\n" + u"\xe8" + " avvenuta <b>%s</b>" % self.timeago() + " fa.")
		else :
			msg_timeago = ("")
			
		self.bot.sendMessage(update.message.chat_id, text="Ciao!\nMi chiamo <b>" + self.cfg.station_name + "</b>.\nLa mia latitudine " + u"\xe8 <b>" + str(self.cfg.location_latitude) +"</b>,\nla mia longitudine " + u"\xe8 <b>" + str(self.cfg.location_longitude) + "</b>.\n\nIl sensore meteo utilizzato " + u"\xe8 " + "di tipo\n<b>" + (self.cfg.sensor_type) + "</b>." + msg_timeago + "\n\nLa temperatura della CPU " + u"\xe8 di <b>" + self.getcputemp() +u"\xb0</b> C" + ".\n\nSpazio libero sulla partizione swpi:\n<b>" + str(disk_free()/1000000) + "</b> Mb\n\nData ed ora di sistema:\n<b>" + str(os.popen('date').readline()).strip() + "</b>\n\nIl sistema " + u"\xe8" + " stato avviato\n<b>" + self.uptime() + "</b> fa.\n\nPer comunicare con te sto utilizzando <b>" + self.botver() + "</b>.\n", parse_mode=telegram.ParseMode.HTML)

		
	@classmethod
	def dati(self, update):		
		txtmessage = (self.nickname(update) + ", amore mio! " + u"\U0001f48b" + "\n")
		
		if globalvars.meteo_data.last_measure_time != None:
			#txtmessage += ("Ecco i dati che ho rilevato per te,\naggiornati al %s alle %s :" % (globalvars.meteo_data.last_measure_time.strftime("%d/%m/%Y"),(globalvars.meteo_data.last_measure_time.strftime("%H:%M:%S"))) + "\n")
			txtmessage += ("Ecco i dati che ho raccolto per te\n<b>%s</b>" % self.timeago() + " fa:\n")
			txtmessage += ("----------------\n")
			if ((globalvars.meteo_data.wind_dir_code) != None) :
				txtmessage += ("La direzione del vento "+ u"\xe8"+"  <b>%s</b>  (%s"%((globalvars.meteo_data.wind_dir_code),str(int(globalvars.meteo_data.wind_dir)))+u"\xb0"+")."+"\n")
			if ((globalvars.meteo_data.wind_ave) != None):
				txtmessage += ("La sua velocit" +  u"\xe0" + " media " + u"\xe8" + " <b>%s</b> " % str(int(globalvars.meteo_data.wind_ave)) + "Km/h.,"  + "\n")
			if ((globalvars.meteo_data.wind_gust) != None):
				txtmessage += ("la raffica di <b>%s</b> " % str(int(globalvars.meteo_data.wind_gust)) + "Km/h."  + "\n\n")
			if ((globalvars.meteo_data.temp_out) != None):
				txtmessage += ("Rilevo una temperatura esterna di <b>%s</b>"%str(globalvars.meteo_data.temp_out).strip()+u'\xb0'+"C," + "\n")
			if ((globalvars.meteo_data.rel_pressure) != None):
				txtmessage += ("pressione di <b>%s</b> " % (globalvars.meteo_data.rel_pressure) + "hPa,"  + "\n")
			if ((globalvars.meteo_data.hum_out) != None):
				txtmessage += ("umidit" +  u"\xe0" + " relativa al <b>%s</b>" % str(int(globalvars.meteo_data.hum_out)) + "%." + "\n")
			if ((globalvars.meteo_data.cloud_base_altitude) != None):
				txtmessage += ("La base cumulo " +  u"\xe8" + " posta a <b>%s</b> " % str(int(globalvars.meteo_data.cloud_base_altitude)) + "metri."  + "\n\n")
			txtmessage += ("A risentirci tesoro! " + u"\u2764\ufe0f" + u"\U0001f48b")
			
			self.bot.sendMessage(update.message.chat_id, text=txtmessage, parse_mode=telegram.ParseMode.HTML)
		else:
			self.bot.sendMessage(update.message.chat_id, text="I dati non sono ancora disponibili.\nRiprova pi" + u"\xf9" + " tardi amore. " + u"\u2764\ufe0f")	
		
		
	@classmethod
	def help(self, update):
		self.bot.sendMessage(update.message.chat_id, text='Ma certo che ti aiuto tesoro!\nPer ora rispondo ai seguenti comandi:\n-----------\n- <b>aiuto</b> (o anche  <b>help</b>)\n- <b>dati</b>\n- <b>webcam</b>\n- <b>info</b> (o anche  <b>sistema</b>)\n- <b>voce</b> (o anche <b>dimmi</b> o <b>parla</b>)\n- <b>ciao</b>\n- <b>#ciao#</b>\n\n--- <b>SOLO</b> per Admin:\n- /list\n- /free\n- /nofree\n- /reboot\n ', parse_mode=telegram.ParseMode.HTML)
		
	
	@classmethod
	def reboot(self, bot, update):
		user = (update.message.chat_id)		
		if self.isadmin(user):
			self.bot.sendMessage(update.message.chat_id, text="Davvero mi vuoi riavviare amore?")
			time.sleep(1)
			self.bot.sendMessage(update.message.chat_id, text= u"\U0001f622 .....")
			time.sleep(1)
			self.bot.sendMessage(update.message.chat_id, text="D\'accordo, lo sai che per te farei qualsiasi cosa.\nA tra poco! " + u"\u2764\ufe0f")
			os.system("sudo reboot")
		else:
			self.noauth(update)
			


	@classmethod
	def ciao(self, update):
		self.bot.sendMessage(update.message.chat_id, text="Ma ciao a te!\nDigita \'<b>aiuto</b>\' se desideri la lista di comandi a cui posso rispondere!", parse_mode=telegram.ParseMode.HTML)
		
	@classmethod
	def sysadmin(self, update):
		con = None
		try:
			con = sqlite3.connect(self.botdb)			
			cur = con.cursor()    
			cur.execute('SELECT userid FROM users where admin = 1')
			try:
				data = cur.fetchone()
				if data:
					return # No error messages are sent to the user if there is already an admin.
					#self.bot.sendMessage(update.message.chat_id, text="Non fare il furbo!", parse_mode=telegram.ParseMode.HTML)
				else:
					user = str(update.message.chat_id).strip()
					nome = self.nickname(update)
					if not self.isuser(user):
						con = None
						try:
							con = sqlite3.connect(self.botdb)			
							con.execute("""INSERT INTO users (userid, name1, admin) VALUES ('%s','%s','1') """ % (user, nome))	
							con.commit()
							self.bot.sendMessage(update.message.chat_id, text="Benvenuto!\nSei il mio nuovo signore e padrone.\n\nFai il bravo!  " + u'\U0001f609', parse_mode=telegram.ParseMode.HTML)
						except sqlite3.Error, e:
							print "Error %s:" % e.args[0]
							usermsg ="ERRORE aggiornando i dati dell\'utente %s !\n" % user
						finally:
							if con:
								con.close()
					else:
						con = None
						try:
							con = sqlite3.connect(self.botdb)			
							con.execute("""UPDATE users SET admin = 1 WHERE userid = "%s" """ % user)			
							con.commit()
							self.bot.sendMessage(update.message.chat_id, text="Benvenuto!\nSei il mio nuovo signore e padrone.\n\nFai il bravo!  " + u'\U0001f609', parse_mode=telegram.ParseMode.HTML)
						except sqlite3.Error, e:
							print "Error %s:" % e.args[0]
							usermsg ="ERRORE aggiornando i dati dell\'utente %s !\n" % user
						finally:
							if con:
								con.close()
					self.bot.sendMessage(update.message.chat_id, text=usermsg, parse_mode=telegram.ParseMode.HTML)
			except:
				#self.bot.sendMessage(update.message.chat_id, text="(DEBUG) - Errore non gestito - query di aggiunta sysadmin", parse_mode=telegram.ParseMode.HTML)
				return
		except sqlite3.Error, e:
			print "Error %s:" % e.args[0]
		finally:
			if con:
				con.close()
		
	
	@classmethod
	def uptime(self):
		try:
			f = open( "/proc/uptime" )
			contents = f.read().split()
			f.close()
		except:
			return "Cannot open uptime file: /proc/uptime"
		total_seconds = float(contents[0])
		# Helper vars:
		MINUTE  = 60
		HOUR    = MINUTE * 60
		DAY     = HOUR * 24
		# Get the days, hours, etc:
		days    = int( total_seconds / DAY )
		hours   = int( ( total_seconds % DAY ) / HOUR )
		minutes = int( ( total_seconds % HOUR ) / MINUTE )
		seconds = int( total_seconds % MINUTE )
		# Build up the pretty string (like this: "N days, N hours, N minutes, N seconds")
		string = ""
		if days > 0:
			string += str(days) + " " + (days == 1 and "giorno" or "giorni" ) + ", "
		if len(string) > 0 or hours > 0:
				string += str(hours) + " " + (hours == 1 and "ora" or "ore" ) + ", "
		if len(string) > 0 or minutes > 0:
				string += str(minutes) + " " + (minutes == 1 and "minuto" or "minuti" ) + ", "
		string += str(seconds) + " " + (seconds == 1 and "secondo" or "secondi" )
		return string;
	
	
	@classmethod
	def parsemsg(self, bot, update):
		user = (update.message.chat_id)

		 #############################################################################
		##	
		##	                     INPUT MESSAGES PARSING BLOCK.
		##	  Carefully read comments if you need to edit/add/remove something below,	
		##	         or else you will probably end with an unresponsive bot.
		## 
		##            Commands starting with '/' are not managed here.
		##     Look below for the 'dp.addTelegramCommandHandler(...)' lines instead.
		##	
		 #############################################################################
		
		txtmessage = (update.message.text).encode('utf-8') #<--- We will manage also special chars & emoticons
		
		if str.upper(txtmessage) == 'SYSADMIN': # 'sysadmin' and #CIAO# commands are meant to be open to the public (no authorization required).
			self.sysadmin(update)
			return
		
		if str.upper(txtmessage).strip() == '#CIAO#': 
				self.eco(update)
				return
				
		if self.isuser('ALL') == False and self.isuser(user) == False: # Is the user authorized? If not, we'll drop his/her request (with the (optional) message below).
			self.bot.sendMessage (update.message.chat_id, text='Non sei autorizzato ad accedere a questa risorsa.\nOra bambino vai, corri a giocare sui tombini aperti!.... ' + u"\U0001f60f")
			return
			
		################################# From this point only authorized users will go ahead.
		
		
		if "Inoltra questo messaggio all'Amministratore di SWPIbot" in txtmessage: # Check if we've just received an 'adduser' formatted request.
			self.adduser(update)
			return
		
		txtmessage = str.upper(txtmessage) # Now we capitalize the whole input message for safe comparing with our following keywords.
		
		########################## At this point we can add answers for some common (we guess...) composite question
		
		if "COME STAI" in txtmessage:
			self.bot.sendMessage(update.message.chat_id, text="Bene tesoro, sto bene grazie. Ora smettila di rompere le balle e dimmi in cosa ti posso essere utile!")
			return
		
		if "COME TI CHIAMI" in txtmessage:
			self.bot.sendMessage(update.message.chat_id, text="Tesoro, mi chiamo " +self.cfg.station_name + ".\nOra smettila di rompere le balle e dimmi in cosa ti posso essere utile!")
			return
		
		if "CHI SEI" in txtmessage:
			self.bot.sendMessage(update.message.chat_id, text="Tesoro, sono un bot.  Chi ti aspettavi, CatWoman?\nOra smettila di rompere le balle e dimmi in cosa ti posso essere utile!")
			return
			
		
		########################## End of the composite questions zone. From this point we are going to accept single words only ...	
		
		txtmessage = txtmessage.replace(" ", "") # <--- ... Because of this line. We remove spaces here, having as a result a single word to compare. 		

		if txtmessage == 'DATI':
			self.dati(update)
			return
		if txtmessage == 'HELP':
			self.help(update)
			return
		if txtmessage == 'AIUTO':
			self.help(update)
			return
		if txtmessage == 'CIAO':
			self.ciao(update)
			return
		if txtmessage == 'INFO':
			self.info(update)
			return
		if txtmessage == 'SISTEMA':
			self.info(update)
			return
		if txtmessage == 'WEBCAM':
			self.webcam(update)
			return
		if txtmessage == 'PARLA':
			self.parla(update)
			return
		if txtmessage == 'DIMMI':
			self.parla(update)
			return
		if txtmessage == 'VOCE':
			self.parla(update)
			return
		# If the user message reaches this point, then we have an unknown command. We send an error message to the user:
		self.bot.sendMessage (update.message.chat_id, text='<b>Eeeh?!... </b>' +  u'\U0001f914' + '\nAmore, scrivi <b>aiuto</b> se non sai da che parte cominciare ' + u'\U0001f48b', parse_mode=telegram.ParseMode.HTML)
		
		######################  END OF THE INPUT MESSAGES PARSING BLOCK.  #################		
		
		
	@classmethod	
	def error(self, update, error):
		log("Telegram Bot: Update %s caused error %s" % (update, error))
	
	@classmethod
	def run(self,cfg):
		self.cfg = cfg
		if os.path.isfile(self.botdb):
			try:
			# Create the EventHandler and pass your bot's token.
				try:
					updater = telegram.ext.Updater(self.BotToken)
				except:
					log("*****************************************************")
					log("*                                                   *")
					log("*    SWPIbot - Telegram Bot ERROR: Invalid token!   *")
					log("*     Please re-check your SWPIbot token config,    *")
					log("*     and that the token have not been revoked.     *")
					log("*            *** SWPIbot NOT started. ***           *")
					log("*                                                   *")
					log("*****************************************************")
					return

				# Get the dispatcher to register handlers	
				dp = updater.dispatcher

				# answer to different commands (commands starting with '/')
				dp.addTelegramCommandHandler("start", self.start)
				dp.addTelegramCommandHandler("list", self.listusers)
				dp.addTelegramCommandHandler("free", self.set_freeaccess)
				dp.addTelegramCommandHandler("nofree", self.set_no_freeaccess)
				dp.addTelegramCommandHandler("reboot", self.reboot)
				
				# on unknown commands goto unknown commands parser to see if it's an user management command (adduser,deluser,setadmin,deadmin)
				dp.addUnknownTelegramCommandHandler(self.unknowncmd)

				# on noncommand (i.e message), parse the message
				dp.addTelegramMessageHandler(self.parsemsg)

				# log all errors
				dp.addErrorHandler(self.error)

				# Start the Bot
				updater.start_polling()
				self.bot = telegram.Bot(token=self.BotToken)
				log ("Telegram Bot listening (" + self.botver()+ ")")
				
			except:
				log ("Error starting Telegram Bot!")
		else:
			log("\n\n") # If SWPIbot.db is not present where it should be, the bot will not start.
			log ("********************************************************************************************")
			log ("   '%s' NOT present. SWPIbot NOT started.   " % self.botdb)
			log ("********************************************************************************************")
			log("\n\n")